
import ReactDOM from 'react-dom';
import React from 'react';

import { Provider } from "react-redux";

import EntityDetails from "../../../ext/components/EntityComponent/entity_details.jsx";

export default function entityEditor( $log, $ngRedux)
{
    return {
        restrict: 'E',
        scope: {
            entity : '=',
            onUpdate : '=',
        },
        template: '<div></div>',
        link: function( $scope, $element, $attributes) {
            $log.debug( 'entityEditor link');
            
            $scope.$on( "$destroy", function () {
                $log.debug( 'entityEditor destroy');
                unmountReactElement();
            });
            
            function unmountReactElement() {
                $log.debug( 'entityEditor unmountReactElement');
                ReactDOM.unmountComponentAtNode( $element[0] );
            }
            
            function _render( entity)
            {
                $log.debug( 'entityEditor _render()', entity);
                ReactDOM.render(<Provider store={$ngRedux}>
                    <EntityDetails entity={entity} onUpdate={$scope.onUpdate}/>
                </Provider>, $element[0]);
            }
            
            $scope.$watch( 'entity', function ( entity) {
                _render( entity);
            })
            
        }
    }
};
