
import template from './entity-list.tmpl.html';

import { removeEntity } from "./store";

export default function entityList($log, $window, $state, $ngRedux)
{
    return {
        restrict: 'E',
        scope: {},
        template: template,
        link: function( $scope, $element, $attributes) {
            $log.debug( 'entityList link');

            propsToScope( $ngRedux.getState());

            var unsubscribe = $ngRedux.subscribe(() => {
                propsToScope( $ngRedux.getState());
            });

            function propsToScope( state)
            {
                $scope.entities =   state.entities.data;
                $scope.selected =   state.entities.selected;
            }

            $scope.$on( "$destroy", unsubscribe )

            $scope.deleteEntity = function(index) {
                var entityName = $scope.entities[index].name;

                if ($window.confirm("Are you sure you want to delete " + entityName + "?")) {
                    $ngRedux.dispatch( removeEntity( index));
                }
            }

            $scope.navigateToEntity = function(index) {
                $state.go('convoworks-editor-service.entity-details', { index });
            }
        }
    }
}
