
export const setEntities = ( entities) => {
  return { type: 'SET_ENTITIES', payload : entities }
}

export const removeEntity = ( index) => {
  return { type: 'REMOVE_ENTITY', payload : index }
}

export const addEntity = ( entity) => {
  return { type: 'ADD_ENTITY', payload : entity}
}

export const updateEntity = ( entity, index) => {
  return { type: 'UPDATE_ENTITY', payload : {
    entity : entity,
    index : index
}}
}

export const selectEntity = ( index) => {
  return { type: 'SELECT_ENTITY', payload : index}
}


const defaultState  =   {
    data : [],
    selected : -1,
    ready : false,
};

export default (state = defaultState, {type, payload}) => {
    switch(type) {
        
        case 'CLEAR_SERVICE':
            return Object.assign( {}, defaultState);
            
        case 'SET_ENTITIES': 
            return Object.assign( {}, state, { data: payload, ready : true});
            
        case 'ADD_ENTITY': 
            return Object.assign( {}, state, { data: [...state.data, payload]});
            
        case 'REMOVE_ENTITY': 
            state.data.splice( payload, 1);
            return Object.assign( {}, state, { data: state.data});
            
        case 'UPDATE_ENTITY': 
            Object.assign( state.data[payload.index], payload.entity);
            return Object.assign( {}, state);
            
        case 'SELECT_ENTITY':
            return Object.assign( {}, state, { selected: payload});
            
        default: 
            return state;
    }
}
