import angular from 'angular';
import ngRedux from "ng-redux";


import convoEditorConfig from './config';
import convoEditorToolbox from './toolbox';
import convoEditorPreview from './preview';
import convoEditorIntents from './intents';
import convoEditorEntities from './entities';
import convoEditorWorkflow from './workflow';
import convoEditorVariables from './variables';
import convoEditorProps from './props';

import ConvoworksEditorController from './convoworks-editor.controller';
import propertiesContext from './properties-context.directive';
import ConvoComponentFactoryService from './convo-component-factory.service';

export default angular
  .module('convo.editor', [ ngRedux, convoEditorConfig, convoEditorToolbox, convoEditorPreview,
  			convoEditorIntents, convoEditorEntities, convoEditorWorkflow, convoEditorProps, convoEditorVariables])
  .controller('ConvoworksEditorController', ConvoworksEditorController)
  .directive('propertiesContext', propertiesContext)
  .service('ConvoComponentFactoryService', ConvoComponentFactoryService)
  .name;
