
import template from './intent-details.tmpl.html';


export default function intentDetails( $log, $state, $ngRedux, $stateParams)
{
    return {
        restrict: 'E',
        scope: {
        },
        require: '^propertiesContext',
        template: template,
        link: function( $scope, $element, $attributes, propertiesContext) {
            $log.debug( 'intentDetails link');
            
            var selected            =   -1;
            var original            =   null; //              =   angular.copy( $scope.intent);
//            $scope.current_intent     =   angular.copy( original);
            
            $scope.onUpdate         =   function( intent) {
                $log.debug( 'intentDetails onUpdate intent', intent);
                $scope.$applyAsync( function () {
                    $scope.current_intent     =   angular.copy( intent);
                });
            }

            $scope.submitIntent = function() {
                propertiesContext.updateConvoIntent( $scope.current_intent, selected);
                $state.go('^.intent-model');
            }

            $scope.isIntentChanged = function() {
                return !angular.equals( $scope.current_intent, original);
            }
        
            propsToScope( $ngRedux.getState());
            
            var unsubscribe = $ngRedux.subscribe(() => {
                $log.debug( 'intentDetails subscribe');
                propsToScope( $ngRedux.getState());
            });
            
            function propsToScope( state)
            {
                $log.debug( 'intentDetails propsToScope', state);
                selected               =   parseInt( $stateParams.index);
                $scope.current_intent  =   state.intents.data[selected];
                
                if ( !original) {
                    original     =   angular.copy( $scope.current_intent);
                }
                
                $scope.entities         =   propertiesContext.getSelectedService().entities;
                $scope.system_entities  =   propertiesContext.getSystemEntities();
            }
            
            $scope.$on( "$destroy", function () {
                $log.debug( 'intentDetails destroy');
                unsubscribe();
            });
            

        }
    }
};
