
import template from './collapse-expand-buttons.tmpl.html';


export default function collapseExpandButtons( $log, UserPreferencesService)
{
    return {
        restrict: 'E',
        scope: false,
        template: template,
        link: function( $scope, $element, $attributes) {
            
            $log.log( 'collapseExpandButtons link');
            
            $scope.expandAll    =   function() {
                $log.log( 'collapseExpandButtons expandAll');
                $scope.$parent.$broadcast( 'ExpandAllRequested');
            }
            
            $scope.collapseAll    =   function() {
                $log.log( 'collapseExpandButtons collapseAll');
                $scope.$parent.$broadcast( 'CollapseAllRequested');
            }
            
            $scope.toggleTitles    =   function() {
                $log.log( 'collapseExpandButtons toggleTitles');
                if ( $scope.areTitlesOn()) {
                    UserPreferencesService.registerData( 'show_default_titles', false);
                } else {
                    UserPreferencesService.registerData( 'show_default_titles', true);
                }
            }
            
            $scope.getTitlesDescription    =   function() {
                if ( $scope.areTitlesOn()) {
                    return 'Click to hide default component titles (only custom names will be displayaed)';
                }
                return 'Click to display default component titles';
            }
            
            $scope.areTitlesOn    =   function() {
                return UserPreferencesService.get( 'show_default_titles', true);
            }
        }
    }
};
