import angular from 'angular';

import './workflow-editor-view.css';
import './selectable-component.css';
import './convoworks-components-container.css';
import './collapse-expand-buttons.css';

import blockComponent from './block-component.directive';
import collapseExpandButtons from './collapse-expand-buttons.directive';
import convoworksComponentsContainer from './convoworks-components-container.directive';
import selectableComponent from './selectable-component.directive';
import subroutineComponent from './subroutine-component.directive';
import ConvoworksAddBlockService from './convoworks-add-block.service';

import contextElement from './context-element.directive';
import contextElementsContainer from './context-elements-container.directive';
import WorkflowEditorController from './workflow-editor.controller';

export default angular
    .module('convo.editor.workflow', [])
    .service('ConvoworksAddBlockService', ConvoworksAddBlockService)
    .directive('blockComponent', blockComponent)
    .directive('collapseExpandButtons', collapseExpandButtons)
    .directive('convoworksComponentsContainer', convoworksComponentsContainer)
    .directive('selectableComponent', selectableComponent)
    .directive('subroutineComponent', subroutineComponent)
    .directive('contextElement', contextElement)
    .directive('contextElementsContainer', contextElementsContainer)
    .controller('WorkflowEditorController', WorkflowEditorController)
    .name;
