
import React from "react";
import ReactDOM from "react-dom";
import { createStore } from "redux";
import allReducers from "../../reducers/index.jsx";
import { Provider } from "react-redux";

// editors
import {TestList} from "./test_list.jsx";
import {ReduxDispatcher} from "./redux_dispatcher.jsx";


function EditorWrapper(props) {
  const store = createStore(
    allReducers,
    window.__REDUX_DEVTOOLS_EXTENSION__ && window.__REDUX_DEVTOOLS_EXTENSION__()
  );
  console.log("Provider with store created!");
  console.log(store);

  console.log("Passed in props", props);


  const entities = props.entities;
  const intents = props.intents;

  return(
    <div className="convogui">
      <Provider store={store}>
        <ReduxDispatcher
          intents={intents}
        >
          <TestList />
        </ReduxDispatcher>
      </Provider>
    </div>
  );
}

export {EditorWrapper}
