<?php

/*
 * IMPORTANT!
 *
 * All constants which are defined here are not and should not be used inside classes (inside library)
 * They are allowed to be used only inside plain php files (e.g. index.php or di-*.php files) - passed as arguments to concrete classes & functions
 *
 * */

// STORAGE - USED FOR FILESYSTEM IMPLEMENTATIONS
define( 'CONVO_DATA_PATH', '/application/data');

// FILESYSTEM CACHE FOLDER
define( 'CONVO_CACHE_PATH', '/application/data/nlp_cach');

// REST INSTALLATION URL ROOT - serves for generating webhook and redirect urls
define( 'CONVO_BASE_URL', 'http://localhost:9090');

/*
 * serves for generating webhook urls
 * */
define( 'CONVO_PUBLIC_REST_BASE_URL', CONVO_BASE_URL.'/rest_public/convo/v1');

// ONLY FOR INSTALLATIONS WHERE THE REST AND THE GUI ARE ON A DIFFERENT DOMAINS (PROTOTYPE ONLY)
define('PROTO_ALLOW_CORS_FROM', 'http://localhost:8080');


// UTIL - TURN OF ALL REQUESTS - (PROTOTYPE ONLY)
define( 'UTIL_PUBLIC_MAINTENACE_MODE', false); // blocks access to everything

// UTIL - OPTION TO TURN ON/OFF GZIP ENCODING FOR REST RESPONSES
define( 'UTIL_DISABLE_GZIP_ENCODING', true); // faster Rest responses, but can cause problemss in development and debuging

// UTIL - OPTION TO TURN ON/OFF GZIP FOR SERVICE PARAMS
define( 'CONVO_STORE_AS_GZ', true);

// UTIL - REQUEST AND RESPONSE DUMPER
define( 'CONVO_DUMP_LIMIT_OF_REQUEST_RESPONSE_PAIRS', 0);
define( 'CONVO_DUMP_PATH', '/application/dump');
define( 'CLASS_IDENTIFIERS_TO_DUMP_REQUESTS_AND_RESPONSES_FROM', ['alexa-skill', 'dialogflow', 'google-actions', 'webchat']);

// UTIL - DUMP FAULTY REQUESTS
define( 'CONVO_ERROR_DUMP_LIMIT_OF_REQUESTS', 15);
define( 'CONVO_ERROR_DUMP_PATH', '/application/error_dump');

// TIMEZONE SET
date_default_timezone_set('Europe/Berlin');


// CONVO - LOG & DEBUG SETTINGS
define( 'CONVO_LOG_PATH', '/application/log');
define( 'CONVO_LOG_LEVEL', 'debug');

