<?php declare(strict_types=1);

namespace Convo\Core;

interface IAdminUserDataProvider
{
    const BASE_CONFIG = [
        'amazon' => [
            'client_id' => '',
            'client_secret' => ''
        ]
    ];
	
	/**
	 * @param string $username
	 * @return IAdminUser
	 * @throws DataItemNotFoundException
	 */
    public function findUser( $username);
    
	
	/**
	 * @param string $userId
	 * @return array
	 */
	public function getPlatformConfig( $userId);
	
	/**
	 * @param string $userId
	 * @param array $config
	 */
	public function updatePlatformConfig( $userId, $config);
}